Index: trunk/hal/tsar_mips32/drivers/soclib_pic.h
===================================================================
--- trunk/hal/tsar_mips32/drivers/soclib_pic.h	(revision 188)
+++ trunk/hal/tsar_mips32/drivers/soclib_pic.h	(revision 205)
@@ -206,24 +206,24 @@
 
 /******************************************************************************************
- * This function enable a HWI/WTI IRQ identified by the <src_chdev> argument,
+ * This function enables a remote HWI/WTI IRQ, identified by the <src_chdev_xp> argument,
  * that contains information on the IRQ type (HWI/WTI), and IRQ index. 
- * It access the relevant XCU mask register, but does not access IOPIC.
- ******************************************************************************************
- * @ lid        : target core local index.
- * @ src_chdev  : local pointer on source chdev descriptor.
- *****************************************************************************************/
-void soclib_pic_enable_irq( lid_t     lid,
-                            chdev_t * src_chdev );
-
-/******************************************************************************************
- * This function disable a HWI/WTI IRQ identified by the <src_chdev> argument, 
+ * It access the remote XCU mask register, but does not access IOPIC.
+ ******************************************************************************************
+ * @ lid           : target core local index (in cluster containing the source chdev).
+ * @ src_chdev_xp  : extended pointer on source chdev descriptor.
+ *****************************************************************************************/
+void soclib_pic_enable_irq( lid_t   lid,
+                            xptr_t  src_chdev_xp );
+
+/******************************************************************************************
+ * This function disables a remote HWI/WTI IRQ, identified by the <src_chdev_xp> argument, 
  * that contains information on the IRQ type (HWI/WTI), and IRQ index.
- * It access the relevant XCU mask register, but does not access IOPIC.
- ******************************************************************************************
- * @ lid        : target core local index.
- * @ src_chdev  : local pointer on source chdev descriptor.
- *****************************************************************************************/
-void soclib_pic_disable_irq( lid_t     lid,
-                             chdev_t * src_chdev );
+ * It access the remote XCU mask register, but does not access IOPIC.
+ ******************************************************************************************
+ * @ lid           : target core local index (in cluster containing the source chdev).
+ * @ src_chdev_xp  : extended pointer on source chdev descriptor.
+ *****************************************************************************************/
+void soclib_pic_disable_irq( lid_t   lid,
+                             xptr_t  src_chdev_xp );
 
 /******************************************************************************************
@@ -266,7 +266,15 @@
 
 /******************************************************************************************
- * This function returns a local pointer on the local XCU base segment.
+ * This function returns the local pointer on the local XCU base segment.
  *****************************************************************************************/
 uint32_t * soclib_pic_xcu_base();
+
+/******************************************************************************************
+ * This function returns the local pointer on a remote XCU base segment.
+ * It is used by the soclip_pic_enable_irq() and soclib_pic_disable_irq() functions.
+ ******************************************************************************************
+ * @ cxy  : target cluster identifier.
+ *****************************************************************************************/
+uint32_t * soclib_pic_remote_xcu_base( cxy_t cxy );
 
 /******************************************************************************************