Index: trunk/platforms/tsarv4_generic_mmu/tsarv4_cluster_mmu/caba/source/include/tsarv4_cluster_mmu.h
===================================================================
--- trunk/platforms/tsarv4_generic_mmu/tsarv4_cluster_mmu/caba/source/include/tsarv4_cluster_mmu.h	(revision 189)
+++ trunk/platforms/tsarv4_generic_mmu/tsarv4_cluster_mmu/caba/source/include/tsarv4_cluster_mmu.h	(revision 234)
@@ -138,36 +138,36 @@
 
 	TsarV4ClusterMmu(sc_module_name  insname,
-                        size_t	 nprocs,			    // number of processors 
-			size_t	 n_x,				    // x coordinate
-			size_t	 n_y,				    // y coordinate
-			size_t	 n_cluster,			    // y + ymax*x
-			const 	 soclib::common::MappingTable &mtd, // direct mapping table
-			const	 soclib::common::MappingTable &mtc, // coherence mapping table
-			const	 soclib::common::MappingTable &mtx, // xram mapping table
-			size_t	 x_width,			    // x field number of bits
-			size_t	 y_width,			    // y field number of bits
-                        size_t	 tgtid_memc,
-                        size_t	 tgtid_xicu,
-                        size_t	 tgtid_fbuf,
-                        size_t	 tgtid_mtty,
-                        size_t	 tgtid_brom,
-                        size_t	 tgtid_bdev,
-                        size_t	 tgtid_mdma,
-                        size_t	 memc_ways,			    // number of ways for MEMC
-                        size_t	 memc_sets,			    // number of sets for MEMC
-                        size_t	 l1_i_ways,			    // number of ways for L1 ICACHE
-                        size_t	 l1_i_sets,			    // number of sets for L1 ICACHE
-                        size_t	 l1_d_ways,			    // number of ways for L1 DCACHE
-                        size_t	 l1_d_sets,			    // number of sets for L1 DCACHE
-                        size_t	 xram_latency,			    // external ram latency
-			bool     io,				    // I/O cluster if true
-                        size_t   xfb,				    // frame buffer pixels
-                        size_t   yfb,				    // frame buffer lines
-                        char*    disk_name,			    // virtual disk name for BDEV
-                        size_t   block_size,			    // block size for BDEV
-                        Loader   loader, 			    // loader for BROM
-                        uint32_t frozen_cycles,			    // max frozen cycles
-                        uint32_t start_debug_cycle,
-                        bool     debug_ok); 
+                        size_t           nprocs,			    // number of processors 
+			size_t           n_x,				    // x coordinate
+			size_t           n_y,				    // y coordinate
+			size_t           n_cluster,			    // y + ymax*x
+			const            soclib::common::MappingTable &mtd, // direct mapping table
+			const            soclib::common::MappingTable &mtc, // coherence mapping table
+			const            soclib::common::MappingTable &mtx, // xram mapping table
+			size_t	         x_width,			    // x field number of bits
+			size_t	         y_width,			    // y field number of bits
+                        size_t	         tgtid_memc,
+                        size_t	         tgtid_xicu,
+                        size_t	         tgtid_fbuf,
+                        size_t           tgtid_mtty,
+                        size_t           tgtid_brom,
+                        size_t           tgtid_bdev,
+                        size_t           tgtid_mdma,
+                        size_t           memc_ways,			    // number of ways for MEMC
+                        size_t           memc_sets,			    // number of sets for MEMC
+                        size_t           l1_i_ways,			    // number of ways for L1 ICACHE
+                        size_t           l1_i_sets,			    // number of sets for L1 ICACHE
+                        size_t           l1_d_ways,			    // number of ways for L1 DCACHE
+                        size_t           l1_d_sets,			    // number of sets for L1 DCACHE
+                        size_t           xram_latency,			    // external ram latency
+			bool             io,				    // I/O cluster if true
+                        size_t           xfb,				    // frame buffer pixels
+                        size_t           yfb,				    // frame buffer lines
+                        char*            disk_name,			    // virtual disk name for BDEV
+                        size_t           block_size,			    // block size for BDEV
+			const Loader    &loader, 			    // loader for BROM
+                        uint32_t         frozen_cycles,			    // max frozen cycles
+                        uint32_t         start_debug_cycle,
+                        bool             debug_ok); 
 
 	~TsarV4ClusterMmu();